// 
// Simple example of calling Lua
//
// Author: Alex V. Boreskoff, <steps3d@narod.ru>
//

#ifdef	__cplusplus
extern "C" {
#endif

#include	"lua.h"
#include	"lauxlib.h"
#include	"lualib.h"

#ifdef	__cplusplus
};
#endif

int main ()
{
	lua_State * lua = lua_open ();						// create Lua context
	
	if ( lua == NULL )
	{
		printf ( "Error creating Lua context.\n" );
		
		return 1;
	}
	
	luaL_openlibs ( lua );								// open standart libraries
														// load and execute a file
	if ( luaL_loadfile ( lua, "test-2.lua" ) )
		printf ( "Error opening test-2.lua\n" );
		
	lua_pcall       ( lua, 0, LUA_MULTRET, 0 );			// ???
	lua_getfield    ( lua, LUA_GLOBALSINDEX, "foo" );   // push global function f on stack
	lua_pushstring  ( lua, "17" );                   	// push first argument on stack
	lua_pushinteger ( lua, 3 );							// push second argument on stack
	lua_pcall       ( lua, 2, 1, 0 );                   // call function taking 2 argsuments and getting one return value
	
														// get return value and print it
	printf ( "Result: %d\n", lua_tointeger ( lua, -1 ) );
	
	lua_close       ( lua );					// close Lua context
	
	return 0;
}

