// 
// Simple example of calling Lua
//
// Author: Alex V. Boreskoff, <steps3d@narod.ru>
//

#ifdef	__cplusplus
extern "C" {
#endif

#include	"lua.h"
#include	"lauxlib.h"
#include	"lualib.h"

#ifdef	__cplusplus
};
#endif


int	ave ( lua_State * lua )							// function to be exported to Lua
{
	int		num = lua_gettop ( lua );
	double	sum = 0;
	
	for ( int i = 1; i <= num; i++ )
		sum += lua_tonumber ( lua, i );
		
	lua_pushnumber ( lua, sum / num );
	lua_pushnumber ( lua, num );
	
	return 2;
}

int main ()
{
	lua_State * lua = lua_open ();						// create Lua context
	
	if ( lua == NULL )
	{
		printf ( "Error creating Lua context.\n" );
		
		return 1;
	}
	
	luaL_openlibs ( lua );								// open standart libraries
	lua_register  ( lua, "ave", ave );
														// load and execute a file
	if ( luaL_dofile ( lua, "test-3.lua" ) )
		printf ( "Error opening test-3.lua\n" );
	
	lua_close     ( lua );					// close Lua context
	
	return 0;
}

